<template>
  <div
    v-if="tableHeadings.length > 0"
    class="table complexHeaderTable">
    <section class="thead">
      <div class="tr">
        <div
          v-for="(item, index1) in tableHeadings.filter(item => !item.hidden)"
          :key="`table-th-${index1}`"
          class="th"
          :class="`_${item.name}${item.filter.has ? ' _filter' : ''} ${item.classes}`">
          <template v-if="item.sorting.has">
            <!-- Классы для направления сортировки: -sorting-up / -sorting-down -->
            <button
              class="table-button-sorting"
              :class="sortClasses[item.sorting.criteria]"
              @click="orderChange(item.sorting.criteria)">
              <span>{{ item.title }}</span>
              <img
                svg-inline
                src="~/assets/svg/redesign/sorting-none.svg">
              <img
                svg-inline
                src="~/assets/svg/redesign/sorting.svg">
            </button>
          </template>
          <template v-else>
            {{ item.title }}
          </template>
          <template v-if="item.filter.has">
            <AppSelect
              class="multiselectThemeSmall"
              placeholder="Выбрать"/>
          </template>
        </div>
      </div>
    </section>

    <section class="tbody">
      <div
        class="tr"
        v-for="(part, index3) in grid.data"
        :key="`part-1${index3}`">
        <div
          class="td"
          v-for="(item, index2) in tableHeadings"
          :key="`table-td-${index3}${index2}`"
          :class="`_${item.name} ${item.classes}`">
          <slot
            :name="`unit-${item.name}`"
            :part="part"/>
        </div>
      </div>
    </section>
  </div>

</template>

<script>
import AppSelect from '~/components/redesign/app-select/app-select';

export default {
  name: 'ComplexHeaderTable',
  components: {
    AppSelect,
  },
  props: {
    tableHeadings: {
      type: Array,
      default() {
        return [];
      },
    },
    grid: {
      type: Object,
      default() { return {}; },
    },
  },
  data() {
    return { };
  },
  computed: {
    sortClasses() {
      return '-sorting-up';
    },
  },
  methods: {
    orderChange(field) {
      return field;
    },
  },
};
</script>

<style scoped lang="postcss">
/* Стили для всех таблицы */
@import "~/assets/css/components/app-table-basic.css";

.table.complexHeaderTable {
  .tr {
    grid-template-columns: 3rem repeat(auto-fit, minmax(5rem, 1fr));
    grid-template-rows: auto;
  }

  .thead {
    .th._filter {
      padding-top: 0;
      padding-bottom: 0;
      justify-content: center;
      font-weight: var(--font-weight-regular);
    }
  }
}
</style>
